.nf
.bp
( 68000 versions of the code words for the file system )
( The address interpreter is 16-bit post-incrementing )
( indirect-threaded.  D7 is the relocation register. )

(  &ptr is the address of a pointer.  fetch the pointed-to )
(  character and post-increment the pointer )
code @c@++ ( &ptr --- char )
 ( the address on the stack points to a double byte pointer )
 ( fetch the byte and increment the pointer )
  word  sp )+ d7 move  d7 a0 lmove  a0 ) d7 move  d7 a1 lmove
  long   d0 clr
  byte a1 )+ d0 move  word d0 sp -) move
  word a1 a0 ) move
c;
 
(  &ptr is the address of a pointer.  store the character into )
(  the pointed-to location and post-increment the pointer )
code @c!++ ( char &ptr --- )
 ( the address on the stack points to a byte pointer )
 ( store into the byte and increment the pointer )
  word  sp )+ d7 move  d7 a0 lmove  a0 ) d7 move  d7 a1 lmove
  word sp )+ d0 move  byte d0 a1 )+ move  
  word a1 a0 ) move
c;
 
: field ( offset size --- ofset+size )
  create over , +
  ;code ( fd --- fd+offset )
     word w ) d0 move sp ) d0 add  d0 sp ) move
c;

( skipwhite                                            )
code skipwhite ( endaddr addr --- endaddr addr' )
  word  sp )+ d7 move   d7 a0 lmove
  word  sp )  d7 move   d7 a1 lmove
  long d0 clr  d1 clr  d2 clr  d3 clr  d4 clr
  word bl # d0 move   tab # d1 move   carret # d2 move  newline # d3 move
  begin
     long  a1 a0 cmpa  u<
  while   
     byte a0 ) d4 move long
     d4 d0 cmp  0<> if    d4 d1 cmp  0<> if
     d4 d2 cmp  0<> if    d4 d3 cmp  0=
  while                         then then then
     byte  a0 )+ tst  long
  repeat
  word a0 sp -) move
c;
 
( ccopy )
code ccopy ( endaddr startaddr toaddr --- newtoaddr )
  word  sp )+ d7 move  d7 a0 lmove
  word  sp )+ d7 move  d7 a1 lmove
  word  sp )+ d7 move  d7 a2 lmove
  begin
     long a2 a1 cmpa  u<
  while
     byte a1 )+ a0 )+ move long
  repeat
  word a0 sp -) move
c;
 
.bp
( 68000 versions of the code words for the file system cont. )

( nextword )
code nextword ( endaddr addr --- addr addr' addr'' )
  word  sp )+ d7 move   d7 a0 lmove
  word  sp )+ d7 move   d7 a1 lmove
  word  a0 sp -) move
  long d0 clr  d1 clr  d2 clr  d3 clr  d4 clr
  word bl # d0 move   tab # d1 move   carret # d2 move  newline # d3 move
  begin
     long  a1 a0 cmpa  u<
  while   
     byte a0 ) d4 move long
     d4 d0 cmp  0<> while    d4 d1 cmp  0<> while
     d4 d2 cmp  0<> while    d4 d3 cmp  0<>
  while
     byte  a0 )+ tst  long
  repeat
  word a0 sp -) move
  long  a1 a0 cmpa  0<>
  if   byte a0 )+ tst long  then
  word a0 sp -) move
c;

( nextcword )
code nextcword ( endaddr addr char --- addr addr' addr'' )
 ( find first occurrence of delimiter "char" in addr:endaddr )
 ( addr' is the address of the delimiter or endaddr if no delimiter was found)
 ( addr'' is the address of the character after the delimiter or endaddr )
 (   if no delimiter was found )
  word  sp )+ d0 move
  word  sp )+ d7 move   d7 a0 lmove
  word  sp )+ d7 move   d7 a1 lmove
  word  a0 sp -) move   ( put addr back on the stack )
  begin
     long  a1 a0 cmpa  u<
  while   
     byte a0 ) d0 cmp long   0<>
  while
     byte  a0 )+ tst  long
  repeat
  word a0 sp -) move
  long  a1 a0 cmpa  0<>
  if   byte a0 )+ tst long  then
  word a0 sp -) move
c;
















