15 /n * stack: input-file
15 /n * stack: output-file

: error-emit stderr fputc stderr flushbuf drop ;
: (error-output
  ['] emit >is token@  output-file push
  ['] error-emit ['] emit (is
;
: (restore-output
  output-file pop  ['] emit (is
;

: newword ( c --- 'word )
  dup  bl =
  if   drop 'word input-file top@ getword
  else      'word swap input-file top@ getcword
  then
;
: fparse-word ( char -- addr len )
  drop ( assumes that you really want blank as a delimiter )
  input-file top@ here getword
  count
;
: fparse ( char -- addr len )
  here swap input-file top@ getcword
  count
;

: norm
  ['] (quit       ['] quit (is
  ['] (word       ['] word (is
  ['] (parse      ['] parse (is
  ['] (parse-word ['] parse-word (is
;
: files-mode 
  ['] \           ['] quit  (is
  ['] newword     ['] word  (is
  ['] fparse      ['] parse (is
  ['] fparse-word ['] parse-word (is
  ['] (error-output    ['] error-output   (is
  ['] (restore-output  ['] restore-output (is
;

: safe-query norm (query  ;
' safe-query is query

: fload ( fd --- f ) ( 1=success, 0=failure )
  input-file sdepth 0=   if  >in @ >r   files-mode  then
  input-file push
  interpret
  input-file pop drop
  input-file sdepth 0=   if  r> >in !  norm then
;

: "load ( str -- )
  dup >r ( str )
  read open dup
  if   >r r@ fload
       r> close
  else drop ascii " emit ." load: can't open " r@ count type cr
  then r> drop
;
: load [compile] "" "load ;

' noop is where
