\ 68000 versions of code words for file system interface
9 constant tab
13 constant carret
10 constant newline

code skipwhite ( endaddr addr --- endaddr addr' )
  sp )+ a0 amove
  sp )  a1 amove
  word bl # d0 move
  begin
     long  a1 a0 cmpa  u<
  while   
     byte a0 ) d0 cmp  u>=
  while
     long 1 a0 addq
  repeat
  normal a0 sp -) move
c;
 
code nextword ( endaddr addr --- addr addr' addr'' )
  sp )+ a0 amove
  sp )+ a1 amove
  a0 sp -) move
  word bl # d0 move
  begin
     long  a1 a0 cmpa  u<
  while   
     byte a0 ) d0 cmp  u<
  while
     long 1 a0 addq
  repeat
  normal a0 sp -) move
  long  a1 a0 cmpa  0<>
  if   byte a0 )+ tst  then
  normal a0 sp -) move
c;

code ccopy ( endaddr startaddr toaddr --- newtoaddr )
  sp )+ a0 amove
  sp )+ a1 amove
  sp )+ d0 amove   long a1 d0 sub
  here 4 + bra  ( jump to the dbra instruction )
  begin
    begin
      byte a1 )+ a0 )+ move long
    d0 dbra
    d0 word clr long
    1 d0 subq
  cs until
  normal a0 sp -) move
c;
 
code nextcword ( endaddr addr char --- addr addr' addr'' )
 ( find first occurrence of delimiter "char" in addr:endaddr )
 ( addr' is the address of the delimiter or endaddr if no delimiter was found)
 ( addr'' is the address of the character after the delimiter or endaddr )
 (   if no delimiter was found )
  sp )+ d1 move
  sp )+ a0 amove
  sp )+ d0 amove
  long a0 d0 sub normal  ( byte count in d1 )
  a0 sp -) move   ( put addr back on the stack )
  here 4 + bra  ( jump to the dbuntil instruction )
  begin
      begin
        byte  a0 )+ d1 cmp  normal
      0= d0 dbuntil
      0= if  ( Character found )
             a0 a1 move  1 a1 subq  a1 sp -) move
             a0 sp -) move
             next
         then
    d0 word clr normal
    1 d0 subq
  cs until
  ( End of buffer reached before character found )
  a0 sp -) move  a0 sp -) move
c;

\  &ptr is the address of a pointer.  fetch the pointed-to
\  character and post-increment the pointer
 
code @c@++ ( &ptr --- char )
 ( the address on the stack points to a double byte pointer )
 ( fetch the byte and increment the pointer )
  sp )+ a0 amove  a0 ) a1 amove
  long   d0 clr
  byte a1 )+ d0 move  normal d0 sp -) move
  normal a1 a0 ) move
c;
 
\  &ptr is the address of a pointer.  store the character into
\  the pointed-to location and post-increment the pointer
 
code @c!++ ( char &ptr --- )
 ( the address on the stack points to a byte pointer )
 ( store into the byte and increment the pointer )
  sp )+ a0 amove  a0 ) a1 amove
  sp )+ d0 move  byte d0 a1 )+ move  normal
  a1 a0 ) move
c;
