68000 Direct-Threaded Code Forth Implementation

   <cycles> / <total-bytes> / <bytes-per-instance>

Next:   ip )+ a0  rmove		8/2 + 4/2   12/4/4
        a0 )  jmp			     8/2/2
					----------
					    20/6/6

  Assembled inline at the end of every code word

Code words:

     Start with the actual code
     End with  Next  inline

Colon Definition:

   Start with:

     docolon l#) jsr  ( new ip on top of stack)	20/6/6
     docolon:  ip  rp -) move			12/2/0
               sp )+ ip move			12/2/0
               Next				20/6/0
						------
						64/16/6

   Or:  	ip  rp -) move		12/2/2
   		6 pc d) ip move		 8/4/4
		Next			20/6/6
					------
				       40/12/12

   End with:
  code unnest   rp )+ ip move			12/2/0
                Next				20/6/0
						------
						32/8/0

					-------	-------
				       72/20/12	96/24/6

Variables:

    dovariable #) jsr   ( pfa on top of stack )  4 bytes  20 cycles
    dovariable: Next

   Or  n pc d) pea
       Next

Constant:

    doconstant #) jsr              4 bytes 20 cycles
    doconstant: sp )+ a0 move              12 cycles
                a0 ) sp -) move            20 cycles
                Next

   Or    <value> l# sp -) move     8 bytes 22 cycles
         Next

User Variable:

    douser #) jsr                         20 cycles
    douser: sp )+ a0 move                 12 cycles
            a0 ) sp -) move               20 cycles
	    up sp ) add                   20 cycles
	    Next

   Or   user# up d) pea       18 cycles
        Next

Deferred Word:

    dodefer #) jsr			20 cycles
    dodefer: sp )+ a0 move
             a0 ) jmp
