\ Experiment with
\ 32-bit relative link field.  The link field contains the offset
\ between its own address and the link field address of the previous
\ word in the chain.  The offset is negative.  The last word in the
\ chain contains 32-bit 0.  The threads contain 16-bit pointers to
\ their chains.
\ Changed words: (find "header <null word> hide n>link l>name.
\ Changed meta:  "create-t n>link-t l>name-t.

hex
code (find    (s string link -- cfa true | str false )
  long  d7 d6 lmove  word d2 clr
  sp )+ d7 move
  begin 0<>
  while
    d7 a1 lmove   ( a1 is lfa )
    sp ) d6 move   d6 a0 lmove  4 a1 addq
    byte a0 )+ d0 move
    a1 )+ d1 move   d1 d2 move   ( length word )
    d0 d1 eor   3f # d1 and ( mask flag bits )   0=
    if  begin   a0 )+ d0 move   a1 )+ d1 move   d0 d1 eor  0<>
        until   7f # d1 and   0= ( found? )   word
        if    a1 sp ) move   40 # d2 and  0<>
             if 1 # sp -) move   else  -1 # sp -) move  then  next
        then
    then   d7 a1 lmove  a1 ) d0 lmove
      0= if  word d7 clr else  long d0 d7 add word  then
  repeat sp -) clr 
  next
c;
decimal
hex
80a0 here l>name-t
: x   (s -- )  end? on ;   !-t immediate
decimal
: hide      (s -- )
   last @   dup n>link   ( nfa lfa )
 ( XXX for now, ignore the msw of addr )
   dup 2@ rot 0 d+ drop ( nfa prev-nfa )
   swap current @ hash !   ;

: n>link     4 -   ;
: l>name     4 +  ;
: reveal   (s -- )
   last @ dup n>link        swap current @ hash !   ;
