: fungetc ( byte fd -- )
  -1 over bfcurrent +!   ( byte fd )
  bfcurrent @ c!
;
\ Returns the position of the first occurrenct of the character in the
\ string, or -1 if the character does not appear in the string.
: cindex ( char string -- index )
  -1 -rot
  count 0
  ?do  ( flag char base )
       2dup i + c@ = if  rot drop i -rot leave  then
  loop
  2drop
;
: skip-separators ( separators fd -- )
  >r
  begin  r@ fgetc dup 0>=  while   ( separators char )
      2dup swap cindex  0<
      if   r> fungetc drop exit
      else drop 
      then
  repeat
  r> 2drop drop
;
variable separator
: scan-field ( where separators fd -- where )
  rot 0 over c! dup >r  1+ -rot
    >r    ( where separators )  ( ret: where fd )
  begin  r@ fgetc dup 0>=  while   ( where separators char )
      2dup swap cindex  0>=
      if   separator !      ( where' separators )  ( ret: where )
           r> 2drop         ( where' ) ( ret: where )
           r> swap over - 1- over c!
           exit
      else rot tuck c! 1+ swap
      then
  repeat
  separator !
  r> 2drop         ( where' ) ( ret: where )
  r> swap over - 1- over c!
;
: next-field ( where separators fd -- where )
  2dup skip-separators  ( where separators fd )
  scan-field   ( where)
;
