create over-voc.f
\ given a the cfa of an action word and the cfa of a vocabulary,
\ executes the action word for every word in the vocabulary
\ the lfa is on the stack when the action word executes, and it must
\ be removed from the stack by the action word.  Used in the metacompiler,
\ but not restricted to that use.

: over-vocabulary   (s cfa-of-word-to-execute voc-cfa --- )
   >body >user   ( word voc-threads )
   here #threads /link * cmove
   begin   
     here #threads wlargest   dup
   while  wa->a  dup  ( word  addr  lfa lfa )
     3 pick execute
     ( word addr lfa )  w@ swap w!
   repeat   2drop drop
;
: word-hook ( lfa -- )
  l>name dup c@ 31 and ?line  .id space space
  key? if quit then
;

