\ A simple-minded string package.  No automatic string allocation 
\ or garbage collection.  Just some primitives to copy strings ( "copy )
\ concatenate strings ( "cat ), allocate space ( "variable ), collect
\ from the input stream  ( " ["] "" [""]  ), emplace ( ", ), and
\ print ( ". )

: "copy ( from to --- ) over c@ 2+ cmove ;
: "len  ( str --- len ) c@ ;
: "cat  ( startstr endstr --- )
( append startstr to the end of endstr )
   2dup c@ swap c@ + >r
   swap count 1+ 2 pick dup c@ + 1+ swap cmove r> swap c! ;
: "variable ( maxsize --- ) create 0 c, allot ;
128 "variable "temp
: ("lit ( -- str ) r> dup count + even >r ;
: "literal compile ("lit here "copy here c@ 1+ allot align
 ; immediate
: (" ( delimiter --- str )
  word dup count + bl swap c! ( add blank at the end )
  "temp "copy "temp  ( move it away from here )
; immediate
: ""  ( --- str )      bl [compile] (" ; immediate
: [""] ( -- ) ( Later: -- str )
  bl [compile] (" [compile] "literal
; immediate
: " ( --- str ) ascii " [compile] (" ; immediate
: ["] ( -- ) ( Later: -- str )
  ascii " [compile] (" [compile] "literal
; immediate
: ". ( str --- ) count type ;
: ", ( string -- )  here "copy here count 1+ even allot drop ;
