\ Terminal control for Televideo 925

only forth also terminals definitions
: t925-at ( row col -- )
  esc =   swap bl + (emit  bl + (emit
;
: t925-ic ( char -- )   esc Q    (emit  ;
: t925-save
   ['] pause >is token@ saved-pause !
   ['] noop ['] pause (is  ( can't allow another process in )
\   esc-prefix  ascii ? (emit
\   (key saved-y ! (key saved-x !
\   (key drop                    ( eat the gratuitous carriage return)
   #out @ saved-x !  td 23 saved-y !
;
: t925-restore
  saved-y @ saved-x @ cursor-to-row-column
  saved-pause @ ['] pause (is
;

terminal: t925
for #lines        24
for #columns      80
for beep          ctl G
for left          ctl H
for right         ctl L
for set-position  t925-at
for insert-char   t925-ic
for delete-char   esc W
for kill-line     esc T
for kill-screen   esc Y
for insert-line   esc E
for delete-line   esc R
for erase-screen  ctl Z
for save-position t925-save
for restore-position t925-restore
end-terminal

only forth also terminals also forth definitions
: televideo t925 ;
: tvi t925 ;
only forth also definitions
