hex
8. lconstant berrvector
lvariable oldberrvec 0. oldberrvec l!

variable berr-occurred

create fieldberr
assembler
\  8 # sp adda     ( 68000 only )

\ Remember that the bus error happened
  a0 sp -) move
  berr-occurred n# a0 rmove
  true n# a0 ) move
  sp )+ a0 move

  word
\68000  8 # sp adda        ( for 68000 only )
\68010  7 #  8 sp d) bset  ( inhibit hardware rerun ) ( for 68010 only )
 rte
c;
: rememberoldvec ( --- )
 ( remember the default value of the bus error vector )
 ( 0. in berrvector means we don't already know )
  oldberrvec l@ 0. l=
  if  berrvector l@l oldberrvec l!  then
;
: catchberr 
  rememberoldvec
  fieldberr n->a berrvector l!l
;
: restoreberr
  oldberrvec l@ berrvector l!l
;

\ Probe tests an address to see if anything is there.  If a read to that
\ address causes a bus error, the flag is returned as false, otherwise the
\ flag is returned as true.
\  Cprobe does the same thing but only reads one byte.
: probe ( laddr -- present-flag )
  berrvector l@l l>r  ( save bus error vector on return stack )
  fieldberr n->a berrvector l!l
   false berr-occurred !
   w@l  drop ( touch the desired location )
   berr-occurred @ 0=  ( check to see if a bus error happened )
  lr> berrvector l!l
;
: cprobe ( laddr -- present-flag )
  berrvector l@l l>r      \ save bus error vector on return stack )
  fieldberr  n->a berrvector l!l
   false berr-occurred !
   c@l  drop              \ touch the desired location )
   berr-occurred @ 0=     \ check to see if a bus error happened )
  lr> berrvector l!l
;
: wprobe ( laddr -- present-flag )
  berrvector l@l l>r      \ save bus error vector on return stack )
  fieldberr  n->a berrvector l!l
   false berr-occurred !
   w@l  drop              \ touch the desired location )
   berr-occurred @ 0=     \ check to see if a bus error happened )
  lr> berrvector l!l
;
decimal
