\ Words to field interrupts
hex
code sr! ( w -- )
  sp )+ d0 move  sp )+ sr wmove
c;
code sr@ ( -- w )
  d0 clr  sr sp -) move
  d0 sp -) move
c;

: .int ( format&vector pclow.w pchi.w sr.w -- )
   ." Interrupt;  Vector " 
  lwsplit 2drop  lwsplit drop  ( format&vector, format must be 0 )
  base @ hex swap . base !
  cr quit
;

create takeint 
assembler
   ' .int >body l# ip  move
   next
forth

variable interrupt-occurred
wvariable vector-used

create notice-interrupt
assembler
   true n# interrupt-occurred  l#) move
   6 sp d) vector-used l#) wmove
   th 2700 # sp ) wmove    ( Set the CPU priority to 7)
   rte
forth

: spl ( priority -- )
  7 and  8 <<  ( shift priority to proper place )
  sr@ [ th 700 negate ] literal and ( mask off the priority bits )
  or   ( replace them with new priority )
  sr!  ( restore to the status register )
;

: catchvector ( vector-address -- )
  takeint swap l!
;
: catch-autovectors
  th 7c th 60 ( don't change the level 7 vector ! )
  do i catchvector /l +loop
;
decimal
