\ PROMPT TTYFREAD  using CP/M BDOS
: PROMPT ." OK " ;  ( should be vectored )
26 CONSTANT TTYENDCHAR ( ^Z for end-of-file from terminal )
: TTYFREAD  ( bflimit bfbase l.byteno fcb --- ... )
  ( --- bflimit bfbase fstart bftop bfend )
  DROP PROMPT  ( bflimit bfbase d.byteno ) ( <-- is ... )
  2 PICK 4 PICK OVER - 1- 255 MIN ( ... addr size )
  OVER 2- C! ( ... addr )
  DUP 2- C.READCONBUF BDOS DROP ( ... addr )
  DUP SWAP 1- C@          ( ... addr nread )
  2DUP + NEWLINE SWAP C!  ( ... addr nread )
  1+                      ( ... addr n-in-buf )
  OVER C@ TTYENDCHAR = IF DROP 0 THEN ( ... addr n-in-buf )
  + ( ... bftop ) 4 PICK ( bflimit bfbase fstart bftop bfend )
;


\ UTILS FOR DEVICE NAME SCANNING
: LSHIFT ( value cnt --- value-left-shifted-by-count )
  ?DUP IF   15 AND  0 DO DUP + LOOP   THEN
;
: 0>= 0< 0= ;
: "= ( str1 str2 --- f )
  COUNT ROT COUNT DROP SWAP  ( addr2 addr1 len2 )
  COMP 0=
;








\ CP/M device table                             wmb,83Oct02
STRUCT
5 FIELD DEVNAME    2 FIELD DEVCLASS    2 FIELD DEVCODE
CONSTANT DEVENT-SIZE
0 CONSTANT CON  2 CONSTANT RDR  4 CONSTANT PUN  6 CONSTANT LST

CREATE DEVTAB
," CON:"  CON ,  -1 ,  ," RDR:"  RDR ,  -1 ,
," PUN:"  PUN ,  -1 ,  ," LST:"  LST ,  -1 ,
," TTY:"  RDR ,   0 ,  ," CRT:"  CON ,   1 ,
," BAT:"  CON ,   2 ,  ," UC1:"  CON ,   3 ,
," PTR:"  RDR ,   1 ,  ," UR1:"  RDR ,   2 ,
," UR2:"  RDR ,   3 ,  ," PTP:"  PUN ,   1 ,
," UP1:"  PUN ,   2 ,  ," UP2:"  PUN ,   3 ,
," LPT:"  LST ,   2 ,  ," UL1:"  LST ,   3 ,
HERE CONSTANT DEVTAB-END

\ CONIN CONOUT DEVIN DEVOUT
: DEVIN  ( bflimit bfbase d.byteno syscall# --- ... )
  ( --- bflimit bfbase fstart bftop bfend )
  0 SWAP BDOS ( bflimit bfbase d.byteno char )
  3 PICK C! 2 PICK ( bflimit bfbase d.byteno bfbase )
  1+ ( newbftop is bfbase+1 ) 4 PICK ( newbfend is bflimit )
;
: DEVOUT ( bfend bftop bfbase d.byteno syscall# --- bfwritten )
  >R LDROP ROT DROP ( bftop bfbase )
  BEGIN 2DUP U> WHILE
     DUP C@ R@    ( bftop bfbase char syscall# )
     BDOS DROP ( bftop bfnext )
  1+ REPEAT   ( bftop bftop )  DROP R> DROP
;
: DEVCLOSE ( fd --- ) DROP ;


\ READROUTINES WRITEROUTINES SYSCALLNUMS
: CONIN TTYFREAD ;
: CONOUT DROP 2 DEVOUT ;
: NULLREAD ( bftop<-bfbase, bfend<-bflimit )
  DROP 2 PICK 4 PICK ;
CREATE READRTNS
  ' CONIN  , ' DEVIN , ' NULLREAD , ' NULLREAD ,
CREATE WRITERTNS
  ' CONOUT , ' NODEV , ' DEVOUT   , ' DEVOUT   ,
CREATE SYSCALLNUMS    1 , 3 , 4 , 5 ,

: SYSCALLNUM ( devent --- syscall# )
  DEVCLASS @ SYSCALLNUMS + @ ;




\ DEVSETUPFD
: DEVROUTINES ( mode devent --- mode readroutine writeroutine )
  DEVCLASS @ ( mode devclass )  OVER READ =
  IF ['] NULLDEV ELSE DUP WRITERTNS + @ THEN  >R
  OVER WRITE = IF DROP ['] NULLREAD ELSE READRTNS + @ THEN
  R> ( mode readroutine writeroutine ) ;
: DEVSETUPFD ( mode fd buf devent --- fd )
  >R  ( mode fd buf )
 ( 2+ is for TTYFREAD which needs to use 0th word for count )
  DUP BUFSIZE @ + SWAP 2+  2 PICK ( mode fd bfend bfbase fd )
  USEBUF ( mode fd )
  R@ SYSCALLNUM OVER FID !
  -1. 2 PICK FSIZE L!   R> ( mode fd devent )
  SWAP >R DEVROUTINES   ' DEVCLOSE  ' NODEV
  R@ USEROUTINES  R@ FMODE !  R>
;

\ SETIOBYTE                                     wmb,83Oct02
HEX
CREATE IOBYTEMASKS  FC , F3 , CF , 3F ,
: SETIOBYTE ( devcode devclass --- )
  OVER 0>=  IF
    DUP IOBYTEMASKS + C@  ( devcode devclass mask )
    3 C@ AND >R  ( devcode devclass )
    LSHIFT R> ( devcode-shifted iobyte ) OR ( newiobyte )
    3 C!
  ELSE DROP DROP THEN
;

DECIMAL




\ FIND-DEVNAME                                  wmb,83Oct02
: FIND-DEVNAME ( name --- devent-addr | 0 )
  0 SWAP
  DEVTAB-END DEVTAB
  DO
    DUP I DEVNAME "=
    IF  SWAP DROP I SWAP LEAVE  THEN
    DEVENT-SIZE
  +LOOP  DROP
;







\ CPMDEVOPEN CPMFOPEN                         wmb,83Oct02
: CPMDEVOPEN ( mode fd buf name --- fd buf 0   |   fd 1 )
  FIND-DEVNAME DUP ( mode fd buf devent devent )
  IF   DUP DEVCODE @ OVER DEVCLASS @ SETIOBYTE
    ( mode fd buf devent ) DEVSETUPFD ( fd ) 1
  THEN
;










