\ A file system backend that uses the input stream as the file,
\ through expect.

: expect-fread ( bfsize bfbase l.byteno fd -- #read l.byteno )
  drop                ( bfsize bfbase l.byteno )
  l>r                 ( bfsize bfbase )  ( ret: l.byteno )
  2dup                ( bfsize bfbase bfsize bfbase )
  swap                ( bfsize bfbase bfbase bfsize )
  ok expect           ( bfsize bfbase )
  span @              ( bfsize bfbase span )
  rot over =          ( bfbase span buffer-full? )
  if    nip           ( #read )
  else  swap over +    newline swap c!   ( span )
        1+            ( #read )
  then
  lr>
;
: expect-setupfd ( bufstart bufend fd )
  >r
  swap r@ usebuf
  0    r@ fid    !
  -1.  r@ fsize l!
  read r@ fmode  !
  ['] expect-fread  ['] nullwrite ['] drop ['] nodev
    r>  useroutines
;
: expect-fopen ( -- fd ) ( 0 if failure )
  find-fd dup (find-fbuf swap ( buf fd )
  >r dup u.bufsize + r@ expect-setupfd r> ( fd )
;
