/*
 * C support routines for the Forth floating point package.
 */

fadd(a,b) double *a, b; { *a+=b; }
fsub(a,b) double *a, b; { *a-=b; }
fmul(a,b) double *a, b; { *a*=b; }
fdiv(a,b) double *a, b; { *a/=b; }
double ffloat(i) int i; { return(i); }
int fint(d) double d; { return(d); }

char *
ftoae(d)
double d;
{
	static char result[100];

	sprintf(result,	"%e", d);
	return(result);
}

char *
ftoaf(d)
double d;
{
	static char result[100];

	sprintf(result,	"%f", d);
	return(result);
}

double 	exp(),	log(),	log10(),
	sqrt(),	pow(),
	sin(),	cos(),	tan(),
	asin(),	acos(),	atan(),
	sinh(),	cosh(),	tanh();

/* To force loading */
double ( (*ffuncs[])()) = {
	exp,	log,	log10,
	sqrt,	pow,
	sin,	cos,	tan,
	asin,	acos,	atan,
	sinh,	cosh,	tanh,
};
