( for keyboard mapping )
: field ( offset size --- ofset+size )
  create over , +
  ;code ( fd --- fd+offset )
     normal w ) d0 move sp ) d0 add  d0 sp ) move
c;
: newstruct 0 ;

hex
0b0  constant STRING
8010.6b01 lconstant SETKEY
0.80   lconstant SHIFTKEYS
0.0    lconstant CAPSLOCK 
0.0001 lconstant CAPSMASK
0.1    lconstant SHIFTLOCK
0.2    lconstant LEFTSHIFT
0.3    lconstant RIGHTSHIFT
0.000e lconstant SHIFTMASK
0.4    lconstant LEFTCTRL
0.5    lconstant RIGHTCTRL
0.0030 lconstant CTRLMASK
0.0080 lconstant UPMASK
0.0100 lconstant CTLSMASK
a0  constant NOP

decimal

1 constant L1
3 constant L2
25 constant L3
26 constant L4
49 constant L5
51 constant L6
72 constant L7
73 constant L8
95 constant L9
97 constant L10

5 constant F1
6 constant F2
8 constant F3
10 constant F4
12 constant F5
14 constant F6
16 constant F7
17 constant F8
18 constant F9

newstruct
4 field tablemask
1 field station
1 field kentry
10 field kstring
constant kiosize

create kio kiosize allot

variable cfd

: openkeyboard 2 [""] /dev/kbd u_open cfd ! ;

: cput ( string where -- )
  dup 10 0 fill
  swap count ( where from len )
  dup 9 > abort" String can only be 9 characters long"
  rot swap cmove
;
: dosetkey ( -- )
  kio   SETKEY   cfd @   u_ioctl
  abort" dosetkey: ioctl failed"
;
: settables ( -- )
  0. kio tablemask l!   dosetkey
  CAPSMASK  kio tablemask l!   dosetkey
  SHIFTMASK kio tablemask l!   dosetkey
  CTRLMASK  kio tablemask l!   dosetkey
  NOP  kio kentry c!
  UPMASK    kio tablemask l!   dosetkey
;

: setkey ( ascii station -- )
  kio station c!
  kio kentry c!
  0 kio kstring c!
  settables
;

: map-char ( char -- char' )
  dup ascii n =
  if   drop linefeed  else
  dup ascii t =
  if   drop tab       then then
;


: put-char ( addr char -- addr+1 )
  over c! ca1+
;
: process-char ( to-addr from-addr -- to-addr'  incr )
  dup c@ dup ascii \ =  ( to-addr from-addr char f )
  if   ( to-addr from-addr char )
       drop 1+ c@ map-char
       put-char  2
  else nip put-char  1
  then
;
: process-escape-sequences ( string -- string' )
  pad count drop
  swap
  count bounds
  ?do i
      process-char
  +loop
  ( strend )
  pad count drop - ( strlen )
  pad c!
  pad
;

: setstring ( string station s# -- )
  STRING +  
  kio kentry c!
  kio station c!
  process-escape-sequences kio kstring cput
  settables
;
