\ Spawn is not nestable, so you can't do one unix call in the middle
\ of preparing the arguments for another one
create spawn.f
decimal

40 /l * constant max-exec-argv
create exec-argv  max-exec-argv allot
\ No environment for now
create exec-envp  0 ,

variable argvp
variable old-here

: argv-strings ( -- old-here )
  exec-argv max-exec-argv erase
  exec-argv argvp !
  here old-here !
;
: carg ( str -- )
  here  argvp @  !   /n argvp +!
  count  ( addr len)
  2dup here swap cmove  ( addr len)
  allot 0 c,
  drop
;
: spawn ( old-here program-name -- successflag )
  exec-envp exec-argv  rot cstr
  td 84 syscall  retval >r
  drop drop drop
  old-here @ dp !
  r>
;
\ Execute the Unix command line specified by string in a subshell
\ This uses the Unix "system()" routine, so unfortunately you always
\ get the Bourne shell
: system ( addr -- )
  cstr 88 syscall ldrop
;
\ Execute the Unix command line specified by the rest of the input line
\ in a subshell.  Bourne shell only.
: sh ( -- ) ( Input Stream:  rest of line is passed to a subshell )
  newline word
  system
;
