\ requires over-voc.f
decimal
\ True if str1 is a substring of str2
code substring?  ( str1 str2 -- f )
  sp )+ a0 move  ( a0 is str2addr)
  d0 clr
  a0 )+ d0 bmove ( d0 is str2len)

  sp )+ a1 move  ( a1 is str1addr)
  d1 clr
  a1 )+ d1 bmove ( d1 is str1len)

  d1 d0 cmp
  0< if false l# sp -) move next then
  d0 clr  ( establish 0 in the condition codes)
  here 4 + bra  ( branch to the dbra instruction)
  begin
     byte a0 )+ a1 )+ cmpm normal
  0<> d1 dbuntil
  d0 0= setif  d0 extw
32\ d0 extl
  d0 sp -) move
c;
\ : unpack-name ( nfa where -- where) \ Strip funny chars from a name field
\   2dup swap c@ td 31 and swap c!  ( nfa where )
\   dup rot count bounds
\   do    ca1+ i c@ over c!
\   loop
\   dup c@  th 7f and swap c!  ( crunch tag bit at end)
\ ;
code unpack-name ( nfa where -- where) \ Strip funny chars from a name field
  sp )+ a0 move  ( a0 is whereaddr)

  sp )+ a1 move  ( a1 is nfaaddr)
  a0 sp -) move

  d1 clr
  a1 )+ d1 bmove ( d1 is nfalen)
  td 31 # d1 word andi normal  ( get rid of funny bits)

  d1 a0 )+ bmove

  here 4 + bra  ( branch to the dbra instruction)
  begin
     a1 )+ a0 )+ bmove 
  d1 dbra

  a0 -) d0 bmove
  th 7f # d0 word andi normal
  d0 a0 ) bmove
    
c;
\ : sindex ( str1 str2 -- n ) \ Warning! str2 gets mangled!
\   2dup c@ swap c@  ( str1 str2 len2 len1)
\   -      ( str1 str2 len2-len1 )
\   dup 0<    ( str1 str2 len2-len1 f)
\   if   2drop drop -1
\   else
\        >r -1 -rot r>  ( -1 str1 str2 len2-len1)
\        1+ 0 
\        do   2dup substring?
\             if rot drop i -rot leave then
\           count over c!  \ Shorten str1 by eliminating first character
\        loop
\        2drop
\   then
\ ;
code sindex ( addr1 len1 addr2 len2 -- n )
  d2 clr   
  sp )+ d0 move
  begin
            sp  ) a0 move
      /n    sp d) d1 move
      /n 2* sp d) a1 move

      d1 d0 cmp
      0< if sp )+ d0 move   sp )+ d0 move   sp )+ d0 move
        -1. l# sp -) move next
      then
      d3 clr  ( establish 0 in the condition codes)
      here 4 + bra  ( branch to the dbra instruction)
      begin
         byte a0 )+ a1 )+ cmpm normal
      0<> d1 dbuntil
      0= if sp )+ d0 move   sp )+ d0 move   sp )+ d0 move
            d2 sp -) move next
      then

      1 sp ) addq
      1 d0   subq
      1 d2   addq
  repeat
c;
variable apropos-string
variable apropos-vocabulary
: apropos-hook ( lfa -- )
  l>name dup pad unpack-name  ( dictionary-str)
  apropos-string @ count rot count sindex ( nfa f)
  -1 <> if  .id else drop then
;
: apropos   ( str -- )
  apropos-string !
   voc-link wa@
   begin   dup ( #threads 2* - ) v>body body>
        dup apropos-vocabulary !
        ['] apropos-hook swap over-vocabulary
      wa@ dup l->w 0= 
   until
   drop
;
