struct ( tm struct returned by 4.2 localtime call)
  /l field tm_sec
  /l field tm_min 
  /l field tm_hour
  /l field tm_mday
  /l field tm_mon
  /l field tm_year
  /l field tm_wday
  /l field tm_yday
  /l field tm_isdst
drop
: (today ( -- timeval-struct-addr )
  64 syscall lretval
;
: today ( -- day month year)
  (today
  dup  tm_mday l@     ( ptr day)
  over tm_mon  l@ 1+  ( ptr day month)
  rot  tm_year l@ 1900 +  ( day month year)
;
: now ( -- secs mins hours )
  (today
  dup  tm_sec  l@     ( ptr seconds)
  over tm_min  l@     ( ptr seconds minutes)
  rot  tm_hour l@     ( seconds minutes hours)
;
: dst? ( -- f) ( true if daylight savings time)
  (today tm_isdst l@ 0<>
;
: time-zone ( -- minutes-west-of-GMT)
  68 syscall lretval
;
: .time-zone ( -- )
  72 syscall lretval
  begin dup c@ dup
  while emit ca1+
  repeat
  drop
;
\ : >hms ( msecs-since-midnight -- msec secs mins hours )
\   60000 um/mod          ( secs,msec hours,mins )
\   60 /mod               ( secs,msec mins hours )
\   rot n->l 1000 um/mod  ( mins hours msec secs )
\   2swap                 ( msec secs mins hours )
\ ;
\ : hms> ( msec secs mins hours -- msecs-since-midnight )
\   60 * +   ( msec secs hours,mins)
\   >r  1000 * +  n->l
\   r>  60000 um* l+
\ ;
: ," ( --string )
  ascii " word dup c@  ( str len )
  here swap 1+         ( str here len+1)
  dup allot  cmove
;
here ," December"
here ," November"
here ," October"
here ," September"
here ," August"
here ," July"
here ," June"
here ," May"
here ," April"
here ," March"
here ," February"
here ," January"
create months  , , , , , , , , , , , ,

: .month ( index -- )
  1- /n * months +  @
  count type
;
: .date ( day month year -- )
  base @ >r  decimal
  swap .month space
  swap 2 .r ." , "
  .
  r> base !
;
: 2.r ( n -- )
  n->l <# # # #> type
;
: .time ( secs mins hours -- )
  base @ >r decimal
  2 .r  ." :" 2.r ." :" 2.r
  space .time-zone
  r> base !	
;
: .now ( -- )
  now .time
;
: .today ( -- )
  today .date
;
  
