create trace-tools.f
only forth also hidden definitions
: probably-cfa? ( cfa -- flag)
  dup origin here within  ( address must be in the dictionary)
  if dup 1- c@ th 80 and  ( there must be a tag bit preceding the cfa)
       if   1 and 0=      ( the address must be even)
       else drop false
       then
  else drop false
  then
;
: reasonable-ip? ( ip -- flag)
  dup  origin here between  ( ip flag)
  if  1 and 0= ( must be even ) else drop false then
;
: find-cfa ( ip -- f cfa ) ( f is true if a ;code encountered on the way )
   false swap
   begin
      /w - ( /w instead of /token because some things aren't token aligned )
      dup token@ ( ip' token )
      dup  ['] (;code  =   if rot drop true -rot then
      ['] here word-type =
    until
\t32   /w -  ( back past the jsr opcode)  
;
: .current-word ( ip -- )
  find-cfa  ( f cfa)
  >name .id ( f)
  if  ." does>" then
;
: .last-executed ( ip -- )
  /token - token@  ( cfa)
  dup probably-cfa? 
  if >name .id else drop ." ??" then
;
: .caller ( ip -- )
  td 18 to-column ." Called from "
  dup .current-word
  td 56 to-column ." at "
  .
;
only forth also definitions
