hex

41.0000 con4 RAMbase
f0.0000 con4 ROMbase

: d, , , ;
: 0., 0. d, ;
\ ( demand-paged format )
( old format )
create header 107. d, 0., 0., 0., 0., 4000. d, 0., 0.,

0  ( space on stack for boot patch )
code standboot
 byte

 RAMbase l# d7 lmove ( set new base address )
         d7 a1 lmove ( address of new location - to )
 ROMbase l# a0 lmove ( address of load point - from )
   .8000 l# d0 lmove ( no. of bytes to move )
  byte
  a0 )+  a1 )+  move ( move a byte )
  word
  here 2- d0 dbra    ( loop )

  ( continue with old boot stuff ***** ) ( **** need to init "first" )
 drop here 2+  ( remember location of immediate field )
( the 0 will be patched later with the actual address of the saved )
( user area )
   0  #      d7  move     d7 up  lmove

  ( ultimately, set these to a safe place, and do autoconfig )
  ' boot-loc >body @ up d) d7 move  d7 ip lmove
  ' rp0      >body @ up d) d7 move  d7 rp lmove
  ' sp0      >body @ up d) d7 move  d7 sp lmove
c;
constant patch-loc

( reset vector )
 ( location 0 contains the initial stack pointer )
 ( location 4 contains the initial pc )

: patchboot ( --- )
 ( change the cold boot entry to contain the initial sp and pc )
 ( Normally, location 0 contains "cold-boot bra" and location 4 )
 ( contains "warm-boot bra".  In the Astraea prom, though, these )
 ( locations will be the initial sp and the initial pc used by the )
 ( hardware reset handler. )
 ( The sp is not set because the cold-boot code sets it before it's used )

  ['] standboot >body 0 ROMbase d+  ( relocate to ROM bank )
  4 2!     ( just patch location 4 - the initial pc )
      ( this location normally contains "warm-boot bra" )
;

: makeheader ( set up an "a.out" style header )
  here user-size + header 6 + ! ( size )
;
: putheader  ( write out the header padded out to fill a page )
  td 32 ( 2048 ) header fd @  write drop
;
: user-init ( val cfa-of-user-var --- )
  >body @ pad + !
;

( 20.0014 con4 romvec ." Sun 1 ROM!" cr ( Sun 1 )
ef.0014 con4 romvec ." Sun 2 ROM!" cr ( Sun 2 )
: make-init-table ( --- )
  up@ pad user-size cmove  ( make a copy of the user variables at pad )
  ['] stand-key?      ['] key?      user-init
  ['] stand-key       ['] key       user-init
  ['] stand-emit      ['] emit      user-init
  ['] (expect         ['] expect    user-init
  ['] stand-cold-hook ['] cold-hook user-init
;
  
: save-stand ( str --- )
  defmode over fcreate fd ! ( make a new file )
  fd @ -1 = 
  if   ." can't create " ".
  else drop ( get rid of filename )
       makeheader  putheader
      here patch-loc !  ( set address of user init table in boot code )
      patchboot
        here 0 fd @  write drop
        make-init-table user-size pad fd @ write drop

       fd @ close
  then
;
decimal
