\ The dump utility gives you a formatted hex dump with the ascii
\ text corresponding to the bytes on the right hand side of the
\ screen.  In addition you can use the SM word to set a range of
\ memory locations to desired values.  SM displays an address and
\ its contents.  You can go forwards or backwards depending upon
\ which character you type. Entering a hex number changes the
\ contents of the location.  DL can be used to dump a line of
\ text from a screen.

\ General Dump Utility - Output                       06Oct83map
: ld.2   (s laddr llen -- )   lbounds l?do   li c@l .2   lloop   ;
: ldln   (s laddr --- )
   cr   ldup 8 ul.r   2 spaces   8. l2dup ld.2 space
   lover l+ 8. ld.2 space
   16.   lbounds l?do   li c@l emit.   lloop   ;
: l?.n    (s l1 l2 -- l1 )
   l2dup l= if  ." \/"  2drop   else   2 l.r   then   space   ;
: l?.a    (s n1 n2 -- n1 )
   l2dup l= if  ." v"  2drop   else   1 l.r   then  ;



\ dump and fill memory utility                        06oct83map
: l.head   (s laddr llen -- laddr' llen' )
   2swap   2dup -16. land  2swap  15. land
   cr 10 spaces
    8. 0. ldo   li l?.n   lloop   space
   16. 8. ldo   li l?.n   lloop   space
   16. 0. ldo   li l?.a   lloop
   lrot l+
;
: ldump   (s laddr llen -- )
   base @ >r  hex
   l.head
   lbounds ldo   li  ldln   16. l+loop
   r>  base !
;
